module SaveTheMonth
  class ChargeDsl
    attr_accessor :expected_balance
    
    def evaluate_recipe(expected_balance, &recipe)
      self.expected_balance = expected_balance
      instance_eval(&recipe)
    end
    
    def method_missing(meth, *args, &blk)      
      charge_name = meth
      
      if block_given?
        expected_balance.add_charge(charge_name, &blk)
      else
        amount, options = args[0], args[1]
        amount_date = Date.parse(options[:at])
        expected_balance.add_timed_charge(charge_name, amount, amount_date)
      end
    end
  end
end