require_relative './recipe_dsl'
require_relative './query_dsl'

module SaveTheMonth
  class ReaderDsl
    attr_accessor :recipe_dsl, :query_dsl
    
    def initialize
      self.recipe_dsl = RecipeDsl.new
    end
    
    def evaluate_recipe(recipe_in_text)
      instance_eval(recipe_in_text)
    end
    
    def recipe(&blk)
      self.recipe_dsl.instance_eval(&blk)
    end
    
    def query(&blk)
      self.query_dsl = SaveTheMonth::QueryDsl.new(recipe_dsl.expected_balance)
      self.query_dsl.instance_eval(&blk)
    end
  end
end