require 'date'
require_relative './expected_balance'
require_relative './payment_dsl'
require_relative './charge_dsl'

module SaveTheMonth
  class RecipeDsl
    attr_accessor :expected_balance, :payment_dsl, :charge_dsl
    
    def initialize
      self.expected_balance = ExpectedBalance.new
      self.payment_dsl = PaymentDsl.new
      self.charge_dsl = ChargeDsl.new
    end
    
    def initial_date(date)
      expected_balance.initial_date = Date.parse(date)
    end
    
    def final_date(date)
      expected_balance.final_date = Date.parse(date)
    end
    
    def initial_amount(amount)
      expected_balance.initial_amount = amount
    end
    
    def to_pay(&block)
      payment_dsl.evaluate_recipe(expected_balance, &block)
    end
    
    def to_charge(&block)
      charge_dsl.evaluate_recipe(expected_balance, &block)
    end
  end
end